#ifndef HISTPLOTBASE_H
#define HISTPLOTBASE_H

#include <vector>
#include <qwt_plot.h>

class HistPlotPrivate;
class QwtPlotCurve;

class HistPlotBase : public QwtPlot
{
    Q_OBJECT
public:
    explicit HistPlotBase (QWidget * p = nullptr);
    ~HistPlotBase() override;
    void setpoints (const std::vector<double> &inx, const std::vector<double> &iny);
    void set_fit_points (const std::vector<double> &inx, const std::vector<double> &iny);
//    std::vector<double> getpointsx() const;
//    std::vector<double> getpointsy() const;
//    std::vector<double> getfitpointsx() const;
//    std::vector<double> getfitpointsy() const;
    void set_x_range(double xmin, double xmax);
    void get_x_range(double *xmin, double *xmax) const;
    QwtPlotCurve *getHistCurve();
    QwtPlotCurve *getFitCurve();

private Q_SLOTS:

private:
    HistPlotPrivate * const d;
};

#endif /* HISTPLOTBASE_H */
