/*
**    Copyright 2013-2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef CALIBRATIONDIALOG_H
#define CALIBRATIONDIALOG_H

#include <QDialog>

class AdcConfig;
class CalAvgConfig;
class CalZeroConfig;
class conf_mem_t;
class QTimer;
class QPixmap;

class CalibrationDialog : public QDialog
{
    Q_OBJECT
public:
    explicit CalibrationDialog(QWidget *parent = nullptr);
    ~CalibrationDialog() override;

Q_SIGNALS:
    void clear();

public Q_SLOTS:
    void setAdcConfMem(const conf_mem_t &);
    void setAdcConfig(const AdcConfig &);
    void setCalAvgConfig(const CalAvgConfig &);
    void setCalZeroConfig(const CalZeroConfig &);
    void keyPressEvent(QKeyEvent * event) override;

protected Q_SLOTS:
    virtual void update() = 0;
    virtual void copy();

protected:
    conf_mem_t * const conf_mem;
    AdcConfig * const adcConfig;
    CalAvgConfig * const calAvg;
    CalZeroConfig * const calZero;
    QPixmap * const pixmap_ok, * const pixmap_error;

private:
};

#endif // CALIBRATIONDIALOG_H
