#ifndef HIST_H
#define HIST_H

#include <vector>
#include "ui_histdialogbase.h"
#include "hist_manager/histmanager.h"

class QTimer;

class HistDialog: public QDialog, public Ui::HistDialogBase
{
    Q_OBJECT

public:
    HistDialog (QWidget* parent = nullptr);
    virtual ~HistDialog();
    th1 get_h() const;
    void update();
    int getid() const;
    void setid( int id );
    QString getName() const;
    const HistPlot *getplot() const;
    void get_fit_param( bool * ffitok, double * fvalue, double * fmean, double * fsigma, double * fnorm ) const;

protected:
    void update_controls();
    void save();
    void Restore();

public slots:
    void show();

private slots:
    void update_view();
    void on_pushButtonSave_clicked();

private:
    th1 h; // cached data
    int myid;
    QTimer *updatetimer;
    std::vector<double> px, fpx, py, fpy;
    double value, mean, sigma, norm;
    int disable_slots;
    int modseq;
    bool fit_ok;
};

#endif /* HIST_H */
