#ifndef SYSMON_IMPL_H
#define SYSMON_IMPL_H

#include <QDateTime>
#include <QObject>
#include <QStringList>
#include <QMap>
#include <QMutex>

typedef QMap<QString,QString> data_t;
typedef QMap<QString,QStringList> sysstats_t;

class SystemMonitorImpl: public QObject {

public:
    SystemMonitorImpl();
    QString get(const QString & name) const;
    data_t get_all() const;

private:
    void read() const;
    void read_meminfo() const;
    void read_stat() const;
    void check_update() const;
    mutable data_t data;
    mutable QDateTime last_updated;
    mutable sysstats_t last_sysstats;
    mutable QMutex mutex;
};

#endif /* SYSMON_IMPL_H */
