#ifndef WAVEFORMMODELADC_H
#define WAVEFORMMODELADC_H

#include "qxw/WaveformData.h"
#include "qxw/WaveformModel.h"

class AdcmEvent;
class AllConfig;
class conf_mem_t;

class WaveformModel_ADC: public WaveformModel
{
    Q_OBJECT

public:
    typedef enum {
        DATA_SOURCE_RAW,
        DATA_SOURCE_CONV,
        } data_source_t;
    explicit WaveformModel_ADC(QObject *parent = nullptr) : WaveformModel(parent) {}
    void addEvent(const AdcmEvent &ev, const conf_mem_t &conf_mem);
    void setSource(data_source_t s) { data_source = s; }
    WaveformDataAll get_conv() const {return wda_conv;}
    WaveformDataAll get_raw() const {return wda;}

private:
    WaveformDataAll get() const { return WaveformDataAll(); }
    //	bool isDisplayBipolar() const {return bipolar_display;}

    //	WaveformDataAll cache;
    //	bool bipolar_display;
    data_source_t data_source = DATA_SOURCE_RAW;
    WaveformDataAll wda_conv;
};

#endif /* WAVEFORMMODELADC_H */
