/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef CONF_RUNTIME_H
#define CONF_RUNTIME_H

#include <QVector>

#include "adcmraw/adcmregs.h"
#include "config/adcconfig.h"

//typedef enum {
//    ADCM_STATUS_UNKNOWN,
//    ADCM_STATUS_DRIVER_OK,
//    ADCM_STATUS_NO_DMA_MEM,
//    ADCM_STATUS_NO_DRIVER,
//    ADCM_STATUS_DRIVER_ERROR,
//    ADCM_STATUS_HOST_ERROR,
//    ADCM_STATUS_DEVICE_ERROR,
//    ADCM_STATUS_UNKNOWN_DEVICE,
//    ADCM_STATUS_OK
//} adcm_status_t;

//typedef union {
//    unsigned int all;
//    struct {
//        unsigned int intloop: 1;
//        unsigned int extloop: 1;
//        unsigned int adcregtest_m: 1;
//        unsigned int adcregtest_s1: 1;
//        unsigned int adcregtest_s2: 1;
//        unsigned int adcregtest_s3: 1;
//        unsigned int unused: 29;
//        } __attribute__ ((packed)) bit;
//} adcm_testpass_t;

class conf_runtime_t
{
public:
    explicit conf_runtime_t(size_t numberOfChannels);
    void clear();
    adcm_runmode_t runmode; // AdcConfig.runmode
    bool run_enable; // just here
    adcm_trigbit_t trigbits; // AdcConfig.trigbits
    unsigned int timestamp_is_utc; // AdcConfig.timestamp_is_utc
    QVector<adcm_chctrl_reg_t> ch_ctrl;
    //    adcm_testpass_t testpass;
    //    adcm_testpass_t testfail;
};

#endif // CONF_RUNTIME_H
