/*
**    Copyright 2010-2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "AdcmChbuf.h"

#include <QTextStream>

QTextStream &operator<<(QTextStream &stream, const adcm_cbuf_flags_t &f)
{
    stream << QString("%1").arg(f.bit.finished ? "finished" : "incomplete");
    stream << QString(" ");
    stream << QString("eval(%1%2%3%4%5%6%7%8)")
                  .arg(f.bit.eval_thr ? "THR " : "")
                  .arg(f.bit.eval_bl ? "BL " : "")
                  .arg(f.bit.eval_int ? "INT " : "")
                  .arg(f.bit.eval_pu ? "PU " : "")
                  .arg(f.bit.eval_clip ? "CLIP " : "")
                  .arg(f.bit.eval_tfine ? "TFINE " : "")
                  .arg(f.bit.eval_tfast ? "TFAST " : "")
                  .arg(f.bit.eval_rms ? "RMS " : "")
                  .arg(f.bit.eval_thr ? "THR " : "");
    stream << QString(", ");
    stream << QString("has(%1%2)")
                  .arg(f.bit.has_clip ? "CLIP " : "")
                  .arg(f.bit.has_pu ? "PU " : "");
    return stream;
}

QTextStream &operator<<(QTextStream &stream, const adcm_cbuf_error_flags_t &f)
{
    stream << QString("err(%1%2%3%4%5%6%7%8)")
                  .arg(f.bit.bl_nodata ? "BL_NODATA " : "")
                  .arg(f.bit.int_nodata ? "INT_NODATA " : "")
                  .arg(f.bit.bl_out ? "BL_OUT " : "")
                  .arg(f.bit.bad_len ? "BAD_LEN " : "")
                  .arg(f.bit.pks_nodata ? "PKS_NODATA " : "")
                  .arg(f.bit.tfit_err ? "TFIT_ERR " : "")
                  .arg(f.bit.tfit_off ? "TFIT_OFF " : "");
    return stream;
}
