/*
**    Copyright 2006-2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ADCM_DEC_H
#define ADCM_DEC_H

#include <cstdint>

typedef enum {
    DM_OFF,
    DM_ZERO,
    DM_AVG,
    DM_REC
} decoder_mode_t;

typedef union {
    uint32_t all;
    struct {
        unsigned int unused_bits_0_6: 7;
        unsigned int eval_sine: 1;
        unsigned int eval_thr: 1;
        unsigned int eval_bl: 1;
        unsigned int eval_int: 1;
        unsigned int eval_clip: 1;
        unsigned int eval_pu: 1;
        unsigned int eval_tfine: 1;
        unsigned int eval_rms: 1;
        unsigned int eval_tfast: 1;
        unsigned int unused_bits_16_31: 16;
    } bit;
} adcm_eval_flags_t;

#endif                          /* ADCM_DEC_H */
