#ifndef _DAQ_IPC_H
#define _DAQ_IPC_H 1

#include "daqtypes.h"
#include "adcm16.h"
#include <QtGlobal>

typedef qint64 evcounts_t;

struct eventstats_t {
    evcounts_t total[ADC_NCH];  // total number of events analysed
    evcounts_t trig[ADC_NCH];   // number of events with trigger on this channel
    evcounts_t ok[ADC_NCH];
    evcounts_t baseerr[ADC_NCH];
    evcounts_t interr[ADC_NCH];
    evcounts_t timeerr[ADC_NCH];
    evcounts_t clip[ADC_NCH];
    evcounts_t pileup[ADC_NCH];
    evcounts_t flag[ADC_NCH];
};

struct decstat_t {
    int desz;                   // buffer size, events
    int ne;                     // events decoded
    int nb;                     // burst number
    int r1;                     // reserved
    int r2;                     // reserved
//    struct eventstats_t es;            // event statistics
};

const char *daq_state_str (daq_state_t st);

#endif                          /* _DAQ_IPC_H */
