#ifndef DAQTYPES_H
#define DAQTYPES_H

typedef enum {
    ST_OFF, ST_RESET, ST_RUN, ST_PAUSE, ST_ERROR, ST_FAILURE
} daq_state_t;

typedef enum {
    MS_OFF,                     // initial (undefined) state
    MS_INIT,                    // initialized
    MS_RESET,                   // after hardware is reset (Full Reset)
    MS_TESTS,                   // doing init-time tests
    MS_PAUSE,                   // ready to begin datataking
    MS_RUN,                     // data taking in progress
    MS_END,                     // processing data
    // MS_XCOMP = 5; // data transfer complete
    MS_FAIL,                    // failure occured
    MS_FAIL_QUIET               // failure occured, no mesage displayed
} main_state_t;

typedef enum {TASK_ERROR = -1, TASK_OK = 0} taskret_t;

#endif /* DAQTYPES_H */
