
#include "adcm16.h"
#include "adcmregs.h"

// register number for channel registers: trheshold, control, counters
unsigned int AdcmRegs::adc_reg_ch_thr (unsigned int ch)
{
    unsigned int b = ch / ADCM_BOARD_NCH;
    unsigned int mch = ch % ADCM_BOARD_NCH;
    return (b * ADCM_BOARD_NREG + (mch << 1) + 1);
}

unsigned int AdcmRegs::adc_reg_ch_hyst (unsigned int ch)
{
    unsigned int b = ch / ADCM_BOARD_NCH;
    unsigned int mch = ch % ADCM_BOARD_NCH;
    return (b * ADCM_BOARD_NREG + mch + 0x60);
}

unsigned int AdcmRegs::adc_reg_ch_fragm (unsigned int ch)
{
    unsigned int b = ch / ADCM_BOARD_NCH;
    unsigned int mch = ch % ADCM_BOARD_NCH;
    return (b * ADCM_BOARD_NREG + mch + 0x50);
}

unsigned int AdcmRegs::adc_reg_ch_fragmlen (unsigned int ch)
{
  unsigned int b = ch / ADCM_BOARD_NCH;
//  unsigned int mch = ch % ADCM_BOARD_NCH;
  return (b * ADCM_BOARD_NREG + ADCM16_FRAGMLEN_REG);
}

unsigned int AdcmRegs::adc_reg_ch_ctrl (unsigned int ch)
{
    unsigned int b = ch / ADCM_BOARD_NCH;
    unsigned int mch = ch % ADCM_BOARD_NCH;
    return (b * 128 + (mch << 1) + 0);
}

unsigned int AdcmRegs::adc_reg_ch_ctrl_s (unsigned int ch)
{
    unsigned int b = ch / ADCM_BOARD_NCH;
    unsigned int mch = ch % ADCM_BOARD_NCH;
    return (b * ADCM_BOARD_NREG + (mch << 1) + 0);
}
/*
unsigned int adc_reg_ch_auxctrl (unsigned int ch)
{
  unsigned int b, mch;

  b = ch / ADCM_BOARD_NCH;
  mch = ch % ADCM_BOARD_NCH;
  return (b * 128 + (mch << 1) + ADCM_BOARD_NCH * 3);
}
*/
unsigned int AdcmRegs::adc_reg_ch_cnt_compat (unsigned int ch)
{
  unsigned int b = ch / ADCM_BOARD_NCH;
  unsigned int mch = ch % ADCM_BOARD_NCH;
  return (b * 128 + (mch << 1) + ADCM_BOARD_NCH * 2);
}

unsigned int AdcmRegs::adc_reg_ch_cnt (unsigned int ch)
{
    unsigned int b = ch / ADCM_BOARD_NCH;
    unsigned int mch = ch % ADCM_BOARD_NCH;
    return (b * ADCM_BOARD_NREG + (mch << 1) + ADCM_BOARD_NCH * 2);
}

unsigned int AdcmRegs::adc_reg_status (int board)
{
    return (board * ADCM_BOARD_NREG + ADCM16_STATUS_REG);
}
