/*
**    Copyright 2019 Ilja Slepnev
**    Copyright 2013-2014 Ivan Filippov
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "firconfig.h"
#include "ConfigStatus.h"

ConfigStatus FirConfig::validate(const QString &title) const
{
    ConfigStatus status(title);

//    if (coef.empty())
//        status << QString("empty (no coefficients)");
    if (offs < 0 || (offs > 0 && offs >= static_cast<int>(coef.size()))) {
        status << QString("bad offs: %1, set default %2").arg(offs).arg(FirConfig().offs);
    }
    if ((bits < 1) || (bits > 32)) {
        status << QString("bad bits: %1, set default %2").arg(bits).arg(FirConfig().bits);
    }
    return status;
}
