//
//    Copyright 2010-2019 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef RunConfigDialog_H
#define RunConfigDialog_H

#include "ui_RunConfigDialog.h"
#include "config/runconfig.h"

class StorageConfig;

class RunConfigDialog : public QDialog, public Ui::RunConfigDialog
{
    Q_OBJECT
public:
    explicit RunConfigDialog(QWidget *parent = nullptr);

Q_SIGNALS:
    void dataChanged(const RunConfig &r);

public Q_SLOTS:
    void setData(const RunConfig &r);

private:
    void update();
    void updateControls();

private slots:
    void on_buttonBox_clicked(QAbstractButton* button);
    void on_doubleSpinBoxTime_valueChanged( double );
    void on_spinBoxEventCount_valueChanged( int );
    void on_checkBoxEventCount_toggled( bool );
    void on_checkBoxTime_toggled( bool );
    void on_groupBoxStopCondition_toggled( bool );

private:
    RunConfig runConfig;
};

#endif // RunConfigDialog_H
