//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef DECST_T_H
#define DECST_T_H

#include <array>

typedef enum {
    decst_n_dummy, // in WaveformDecoder::decode_work
    decst_n_vld,   // in WaveformDecoder::decode_work
#ifdef FIT_SINE
    decst_n_sine,
#endif
    decst_n_thr,    // in WaveformDecoder::decode_work
    decst_n_rms,    // in WaveformDecoder::decode_work
    decst_n_bl,     // in WaveformDecoder::decode_work
    decst_n_int,    // in WaveformDecoder::decode_work
    decst_n_clip,   // in WaveformDecoder::decode_work
    decst_n_mwb,    // in WaveformDecoder::decode_work
    decst_n_mwbso,  // in WaveformDecoder::decode_work
    decst_n_conv,   // in WaveformDecoderPeaks::decode_work
    decst_n_pksrch, // in WaveformDecoderPeaks::decode_work
    decst_n_pu,     // in WaveformDecoderPeaks::decode_work
    decst_n_tfast,  // in WaveformDecoderPeaks::decode_work
    decst_n_dtcut,  // in WaveformDecoderPeaks::decode_work
    decst_n_fit,    // in WaveformDecoderPeaks::decode_work
    decst_n_rawdec, // in DecodeManager::appendFrame
    decst_n_hist,   // in DecodeWorker::processEvent
    decst_n_all,    // in WaveformDecoder::decode
    decst_n_items
} decst_items_t;

typedef std::array<double, decst_n_items> decst_t_t;

#endif // DECST_T_H
