//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef WINDOWFUNCTION_H
#define WINDOWFUNCTION_H

/// Window functions
typedef enum {
    WF_BARTHANN = 1,
    WF_BARLETT = 2,
    WF_BLACKMAN = 3,
    WF_BLACKMANHARRIS = 4,
    WF_BOHMAN = 5,
    WF_FLATTOP = 6,
    WF_GAUSS_075 = 7,
    WF_GAUSS_050 = 8,
    WF_GAUSS_025 = 9,
    WF_HAMMING = 10,
    WF_HANN = 11,
    WF_NUTTALL = 12,
    WF_RECT = 13,
    WF_TRIANG = 14,
    WF_TUKEY_075 = 15,
    WF_TUKEY_050 = 16,
    WF_TUKEY_025 = 17
} fwinf_t;

/// i = 0, 1, ..., m
double windowingFunction (fwinf_t win_type, double i, int m);

class WindowFunction
{
public:
    WindowFunction();
};

#endif // WINDOWFUNCTION_H
