/*
**    Copyright 2006-2019 Ilja Slepnev
**    Copyright 2013-2014 Ivan Filippov
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef _FIR_TYPES_H
#define _FIR_TYPES_H

#include <ostream>
#include <QVector>

const int FIRFILE_MAGIC = 0x20524946;
const unsigned int FIRMAXLEN = 256;
const unsigned int FIRMAXHALF = (FIRMAXLEN/2+1);

class QTextStream;

class dblfir_t
{
public:
    dblfir_t() : klen(0), offs(0), coef(FIRMAXLEN) {}
    bool operator==(const dblfir_t &other) const {
        return true
                && klen == other.klen
                && offs == other.offs
                && coef == other.coef
                ;
    }
    unsigned int klen;
    int offs;
    QVector<double> coef;
};

#endif                          /* _FIR_TYPES_H */
