/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef HISTMERGER_H
#define HISTMERGER_H

#include <QObject>
#include <QMap>
#include "hist_manager/hist_manager_types.h"

class HistList;
class QTimer;

class HistMerger : public QObject
{
    Q_OBJECT
public:
    explicit HistMerger(QObject *parent = nullptr);

Q_SIGNALS:
    void histogramsChanged(const HistList &);

public Q_SLOTS:
    void addHistograms(const HistList &r);
    void sendHistograms();
    void clearAllHists();
    void clearHist(const hist_index_t &index);

private:
    HistList * const histList;
    QTimer * const sendTimer;
    QMap<hist_index_t, int> modseq;
};

#endif // HISTMERGER_H
