#ifndef ADCM_DF_H
#define ADCM_DF_H

#include <QtGlobal>
#include <QVector>
#include <QMap>
#include <QMetaType>
#include <array>

#include "adcm16.h"

const quint16 STOR_ID_CMAP = 0x504D;    /* 'MP' */
const quint16 STOR_ID_EVNT  = 0x5645;    /* 'EV' */
const quint16 STOR_ID_CNTR  = 0x5443;    /* 'CT' */

#pragma pack(push, 1)
struct stor_packet_hdr_t {
  quint16 id;                 // data block ID
  quint16 size;               // block size, bytes
};

struct stor_ev_hdr_t {
  quint8 np;                  // number of pulses following
  quint8 reserved1;
  quint16 reserved2;
  quint32 ts;                 // timestamp, 10 ns step
};

struct stor_puls_t {
  quint8 ch;
  quint8 flags;
  float a; // Mean value relatively baseline
  float t; // Peak time, ns
  float w; // Peak width, ns
};

struct adcm_counters_t {
    void clear() { *this = adcm_counters_t(); }
    void resize(quint32 _n) { n = _n;}
    quint32 n = 0;
    double time = 0;
    std::array<quint32, ADC_NCH> rawhits = {};
};
#pragma pack(pop)

Q_DECLARE_METATYPE(adcm_counters_t)

/*
class AdcHitCounters
{
public:
    AdcHitCounters() : time(0) {}
    double time;
    QVector<quint32> rawhits;
};
*/

#endif /* ADCM_DF_H */
