#ifndef ADCM_RAW_TYPES_H
#define ADCM_RAW_TYPES_H

/*****************************************************************************/
/*  Internal data structures                                                 */
/*****************************************************************************/
#include <cstddef>

typedef struct {
    unsigned int variable:26;     // depends on type ID
    unsigned int id:6;            // data type ID (0)
} __attribute__ ((packed)) adcm_data_header_t;

size_t adcm_block_len (const adcm_data_header_t * h);

typedef struct {
    unsigned int crc:32;          // CRC-32
} __attribute__ ((packed)) adcm_data_trailer_t;

typedef struct {
    unsigned int bits:4;          // sample bits
    unsigned int spw:2;           // samples per word
    unsigned int ns:12;           // number of samples
    unsigned int ch:8;            // channel
    unsigned int id:6;            // data type ID (0)

    unsigned int ec:16;           // event count
    unsigned int bc:16;           // burst count
} __attribute__ ((packed)) adcm_data_header_0_t;

typedef struct {
    unsigned int tslo:32;          // timestamp 31:0
    unsigned int tshi:32;          // timestamp bits 63:32
} __attribute__ ((packed)) adcm_data_trailer_0_t;

typedef struct {
    unsigned int wpc:5;           // words per channel
    unsigned int nc:8;            // number of channels
    unsigned int reserved:13;
    unsigned int id:6;            // data type ID (1)
} __attribute__ ((packed)) adcm_data_header_1_t;

typedef struct {
    unsigned int ts:32;           // timestamp
    unsigned int crc:32;          // CRC-32
} __attribute__ ((packed)) adcm_data_trailer_1_t;

#endif /* ADCM_RAW_TYPES_H */
