#ifndef QXW_WAVEFORMFILTER_H
#define QXW_WAVEFORMFILTER_H

#include "dsplib/fftengine.h"
#include "qxw/WaveformData.h"

class WaveformFilterBase {
public:
    WaveformDataAll filterAll(const WaveformDataAll &wd) const;
    virtual WaveformData filter(const WaveformData &wd) const = 0;
    virtual ~WaveformFilterBase() { }
};

class WaveformFilterFIR: public WaveformFilterBase {
public:
    WaveformFilterFIR();
    virtual WaveformData filter(const WaveformData &wd) const;
private:
    std::vector<double> firkernel;
};

class WaveformFilterFFT: public WaveformFilterBase {
public:
    virtual WaveformData filter(const WaveformData &wd) const;
private:
    mutable RFFTEngine fft;
};

#endif /* QXW_WAVEFORMFILTER_H */
