#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QThread>

#include "Config.h"

class QTimer;
class QLabel;
class QtMregDevice;

class DiscoverDialog;
class DeviceDescription;
class QHostAddress;

namespace Ui {
class MainWindow;
}


class MainWindow : public QMainWindow
{
    Q_OBJECT
public:
    explicit MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private Q_SLOTS:
    void on_actionAbout_triggered();

    void on_pushButtonChange_clicked();
    void on_comboBoxRegAddr_currentIndexChanged(int);
    void on_lineEditRegAddr_textEdited(const QString);
    void on_comboBoxRegType_currentIndexChanged(int);
    void on_pushButtonRead_clicked();
    void on_pushButtonWrite_clicked();

    void deviceConnected();
    void deviceDisconnected();
    void deviceTempChanged(double temp);
    void deviceStatusUpdated(QString s);

private:
    void connectToDevice(const DeviceDescription dc);
    bool saveConfig(bool checkWriteVal=true);
    void restoreGui();
    void updateLineEditWriteLen();

    Ui::MainWindow *ui;
    Config config;
    QtMregDevice  * dev;
    bool connectedState;
    DiscoverDialog * const discoverDialog;
    double testValue;
    quint64 curDevSerial;
};

#endif // MAINWINDOW_H
