#include "DeviceHistory.h"

#include <QDebug>

void DeviceHistory::deviceDiscoveredAll(const DeviceDescription &dd)
{
    if(!currentState.contains(dd.getIndex())){
        onlineTime[dd.getIndex()] = QDateTime::currentDateTime();
        qInfo().noquote() << QDateTime::currentDateTime().toString("yyyy/MM/dd HH:mm:ss")
                << "New device:"<< dd.getModelStr()<<"\t"<<dd.getSerialIdStr();
    }
    currentState[dd.getIndex()] = dd;
}

void DeviceHistory::deviceExpired(DeviceIndex i)
{
    if(!currentState.contains(i)) {
        qWarning() << "DeviceHistory has no info about expired device:"<<i;
        return;
    }
    const DeviceDescription &dd = currentState[i];
    quint64 upTime = onlineTime[i].msecsTo(QDateTime::currentDateTime());
    quint64 upH = upTime/3600000;
    quint64 upM = (upTime/60000)%60;
    quint64 upS = (upTime/1000)%60;
    qInfo() << QDateTime::currentDateTime().toString("yyyy/MM/dd HH:mm:ss")
            << "DevExpired:"<< dd.getModelStr()<<"\t"<<dd.getSerialIdStr()
            <<"\tupTime:"<<upH<<":"<<upM<<":"<<upS;
    onlineTime.remove(i);
    currentState.remove(i);
}
