/*
**    Copyright 2020 Ivan Filippov, Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

class DiscoverDialog;
class DeviceDescription;
class DeviceIndex;

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = nullptr);
    ~MainWindow();
    virtual void closeEvent(QCloseEvent *event);

private slots:
    void on_actionExit_triggered();
    void on_actionAbout_triggered();

    void onDeviceDiscovered(const DeviceDescription &dd);
    void onDeviceDiscoveredAll(const DeviceDescription &dd);
    void onDeviceExpired(const DeviceIndex &i);

private:
    Ui::MainWindow *ui;
    DiscoverDialog * const discoverDialog;
};

#endif // MAINWINDOW_H
