#ifndef RUNCONTROL_H
#define RUNCONTROL_H

#include <QWidget>

enum RC_STATE{RC_RESETTING=0, RC_STOPPED=1, RC_STARTING=2, RC_STARTED=3, RC_STOPPING=4, RC_ERROR=5};
QString getRunControlStateStr(RC_STATE st);

namespace Ui {
class RunControl;
}

class RunControl : public QWidget
{
    Q_OBJECT

public:
    explicit RunControl(QWidget *parent = nullptr);
    ~RunControl();
    bool setState(RC_STATE state); // false on error
    RC_STATE getState() const { return curState; }
    bool waitState(RC_STATE st, int timeoutMs=1000);
    void setButtonsEnable(bool enabled);

signals:
    void stateChanged(RC_STATE state, uint stateIndex);

private slots:
    void on_pushButtonStart_clicked();
    void on_pushButtonStop_clicked();
    void stateTimedOut();

private:
    void updateStateButtons();

    Ui::RunControl *ui;
    RC_STATE curState;
    uint curStateIndex;
    QTimer * const transitionStateTimer;
};

#endif // RUNCONTROL_H
