#ifndef STATISTICDIALOG_H
#define STATISTICDIALOG_H

#include <QDialog>
#include <QMap>

#include "Analizer.h"
#include "Combiner.h"
#include "TcpClient.h"
class QTableWidget;

namespace Ui {
class StatisticDialog;
}

class StatisticDialog : public QDialog
{
    Q_OBJECT

public:
    explicit StatisticDialog(QWidget *parent = nullptr);
    ~StatisticDialog();

public slots:
    virtual void setVisible(bool visible);
    void analyzerStatUpdated(const AnalyzerStat &s);
    void updateTcpStatistic(int index, const TcpStatistic &statistic);
    void analizerListUpdated(QVector<Analizer *>, QMap<int, QString> clientNames);
    void updateCombinerStats(const CombinerStats &_combStat);

private slots:
    void updateStat();

private:
    void init();
    int addAnalyzer(int id, QString name);
    int addClient(const TcpStatistic &s);
    void updateTableSize(QTableWidget *table);
    int getAnalRowById(int id) const;
    int getClientRowById(int id) const;
    void updateAnalStat();
    void updateTcpStat();

    Ui::StatisticDialog *ui;
    QMap<int, AnalyzerStat> analyzerStatMap;
    QMap<int, AnalyzerStat> analyzerStatMapPending;
    QMap<int, TcpStatistic> tcpStatMap;
    QMap<int, TcpStatistic> tcpStatMapPending;
    CombinerStats combStat;
    QTimer * const refreshTimer;
};

#endif // STATISTICDIALOG_H
