#ifndef MSCREGS_H
#define MSCREGS_H

#include <qglobal.h>

enum {
    REG_START = 0x81, //rw: 1 start, 0 stop
    REG_CH_GROUP =0x82, //rw, [0] 16 channels, 7-bit counter per channel
                        //    [1] 8 channels, 14-bit counter per channel
                        //    [2] 4 channels, 28-bit counter per channel
                        //    [15:3] reserved
    REG_COMPSTATE = 0x84,  //ro
    REG_SPILLSTATE = 0x85, //ro
    REG32_SPILL_PLOT_STEP = 0x92,    //rw
    REG32_SPILL_PLOT_CUR_ADDR  = 0x94,  //ro
    REG32_SPILL_PLOT_OFFSET = 0x96,    //rw
    REG_CTRL = 0x40,

    // Spill registers
    REG32_SPILL_COUNTER = 0x90, //ro
    REG64_SPILL_TS = 0xA4,  //r0 32-bit TAI, (28-bit 8ns cyclCnt) + (4-bit flags)
    REG64_START_TS = 0xA0,  //ro
    REG_DAC_SPI_1 = 0x200, //rw
    REG_DAC_SPI_2 = 0x201,  //rw

    REG32_CH_HIST_STEP_BASE = 0x300, //rw, 16 32-bit registers

    REG_SPILL_CNT_BASE = 0xA00, // RO, 16 32-bit counters
    REG_CYCLE_CNT_BASE = 0xA20, // RO, 16 32-bit counters

    REG_TEST = 0x80, //test
};


enum {
    MEM_TRIG_TIME_HIST_BASE = 0x0, // 16 0x2000 len blocks
    MEM_SPILL_PLOT_BASE = 0x20000, // 16 0x2000 len blocks
};
const quint32 HIT_TIME_HIST_SIZE = 0x2000;
const quint32 SPILL_PLOT_SIZE = 0x2000;

enum {
    DAC_CMD_RESET = 0xF000, // DAC Reset
    DAC_CMD_SINGLE_UPDATE = 0xA002 // LDAC Single Update
};
#endif // MSCREGS_H
