//
//    Copyright 2015 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <QCoreApplication>
#include "pnp-server/PNPServer.h"
#include "PNPBeacon.h"

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    PNPBeacon *beacon = new PNPBeacon(a.arguments());
    PNPServer * pnpServer = new PNPServer();
    QObject::connect(beacon, SIGNAL(sendDescriptio(ProgramDescription)),
                     pnpServer, SLOT(changeProgramDescription(ProgramDescription)));

    int ret = a.exec();
    delete beacon;
    delete pnpServer;
    return ret;
}
