/*
**    Copyright 2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SLOWCONTROLSERVER_P_H
#define SLOWCONTROLSERVER_P_H

#include <QtGlobal>
#include <QString>

#include "SpillPlotData.h"
#include "TriggerHistogramData.h"
#include "base/RcRunId.h"

class QJsonObject;

class SlowControlServerPrivate {
    Q_DISABLE_COPY(SlowControlServerPrivate)
    // Q_DECLARE_PUBLIC(SlowControlServer)
public:
    SlowControlServerPrivate() = default;

    QJsonObject getRcDevice() const;
    QJsonObject getSpillJson() const;
    QJsonObject getTrigJson() const;
    QJsonObject getDaq() const;
    QString getRcBlock() const;
    QByteArray constructResponse() const;

    QString daqState = "INIT";
    QString daqStatus;
    RcRunId runId;
    QString rcState;
    QString rcDescr;
    quint32 spillCount = 0;
    quint64 evNumber = 0;
    SpillPlotData lastSpillPlot;
    TriggerHistogramChannelData lastTrigData;
};

#endif // SLOWCONTROLSERVER_P_H
