/*
**    Copyright 2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SPILLPLOTDATA_H
#define SPILLPLOTDATA_H

#include <QMetaType>
#include <QVector>

class SpillPlotData
{
public:
    QVector<quint32> data;
    quint32 spillCount = 0;
    quint32 spillCurrentTimeMs = 0;
    double stepSec = 1.0;
    double startOffset = 0.0; // seconds
};

Q_DECLARE_METATYPE(SpillPlotData)

#endif // SPILLPLOTDATA_H
