/*
**    Copyright 2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TRIGSTATISTICSWRITER_H
#define TRIGSTATISTICSWRITER_H

#include <QObject>

#include "SpillPlotData.h"
#include "TrigStatus.h"
#include "TriggerHistogramData.h"

class TrigStatisticsWriter : public QObject
{
    Q_OBJECT
public:
    explicit TrigStatisticsWriter(QObject *parent = nullptr)
        : QObject(parent), enable(false) {}
    void writeStatisticsDump(const TrigStatus &newStatus, const SpillPlotData &newSpd, const TriggerHistogramData &newThd);
public slots:
    void setStatusDumpEnable(bool val);
    void setStatusDumpDirName(const QString &str);

private:
    void writeFile();
    bool enable;
    QString dirName;
    TrigStatus status;
    SpillPlotData spd;
    TriggerHistogramData thd;
};

#endif // TRIGSTATISTICSWRITER_H
