/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TRIGGERHISTOGRAMDATA_H
#define TRIGGERHISTOGRAMDATA_H

#include <QMetaType>
#include <QVector>
#include <QMap>
#include <QtGlobal>

class TriggerHistogramChannelData
{
public:
    TriggerHistogramChannelData() : overflowCount(0), spillCount(0), spillCurrentTimeMs(0), channel(0) {}
    bool isEmpty() const;
    int getFirstNotemptyBin() const;
    int getLastNotemptyBin() const;
    QVector<double> px;
    QVector<quint32> data;
    quint64 overflowCount;
    quint32 spillCount; // duplicated TriggerHistogramData::spillCount
    quint32 spillCurrentTimeMs;// duplicated TriggerHistogramData::spillCurrentTimeMs
    quint32 channel;
};

Q_DECLARE_METATYPE(TriggerHistogramChannelData)

class TriggerHistogramData
{
public:
    TriggerHistogramData() : spillCount(0), spillCurrentTimeMs(0) {}
    QMap<int, TriggerHistogramChannelData> histograms;
    quint32 spillCount;
    quint32 spillCurrentTimeMs;
};
Q_DECLARE_METATYPE(TriggerHistogramData)


#endif // TRIGGERHISTOGRAMDATA_H
