#ifndef INLCHECKDIALOG_H
#define INLCHECKDIALOG_H

#include <QDialog>
#include <QMap>

#include "mldiscover/DeviceIndex.h"
#include "HistMngrWidget.h"
#include "HrbCalib.h"

class QTreeWidgetItem;
class QAbstractButton;
class QComboBox;

namespace Ui {
class InlCheckDialog;
}

class InlCheckDialog : public QDialog
{
    Q_OBJECT

public:
    explicit InlCheckDialog(QWidget *parent = nullptr);
    ~InlCheckDialog() override;

signals:
    void retry() const;

private slots:
    void on_treeWidget_itemSelectionChanged();
    void on_pushButtonUpdateHrbCal_clicked();
    void on_buttonBox_clicked(QAbstractButton *button);

public slots:
    void resultUpdated(const InlCheckResults &res);
    void hrbPresetChanged(QString preset);


protected:
    void showEvent(QShowEvent *ev) override;

private:
    QComboBox *createHrbComboBox(DeviceIndex index);
    void refreshModResults(DeviceIndex devIndex);
    void uploadHrbCal(QString folder=QString());
    DeviceIndex get_selected_device() const;
    void save_results();

    Ui::InlCheckDialog *ui;
    QTreeWidgetItem * const rootTreeItem;
    QMap<DeviceIndex, QTreeWidgetItem *> modTreeItems;
    QMap<DeviceIndex, QMap<int, double> > deviceOffsets;
    InlCheckResults inlResults;
    HrbCalib hrbCalib;
};

#endif // INLCHECKDIALOG_H
