#ifndef TDCTTVXSMAPDIALOG_H
#define TDCTTVXSMAPDIALOG_H

#include <QDialog>

#include "mldiscover/DeviceIndex.h"
#include "Config.h"

class AnalyzerStats;
class QComboBox;

namespace Ui {
class TdcTtvxsMapDialog;
}
class QAbstractButton;

class TdcTtvxsMapDialog : public QDialog
{
    Q_OBJECT

public:
    explicit TdcTtvxsMapDialog(const AnalyzerStats analyzerStats,
                               const TdcTtvxsMapType &ttMap,
                               QWidget *parent = nullptr);
    ~TdcTtvxsMapDialog();
    TdcTtvxsMapType getDevMap() const { return  tdc_ttvxs_map; }

private slots:
    void currentTextChanged();
    void on_buttonBox_clicked(QAbstractButton *button);

private:
    void initGui();
    QComboBox *createComboBox(DeviceIndex prefered_ttvxs);
    DeviceIndex getTtvxsIndex(QComboBox *cb, int id=-1);
    Ui::TdcTtvxsMapDialog *ui;

    TdcTtvxsMapType original_tdc_ttvxs_map;
    TdcTtvxsMapType tdc_ttvxs_map;
    QList<DeviceIndex> presentTdc;
    QList<DeviceIndex> absentTdc;
    QList<DeviceIndex> presentTtvxs;
    QList<DeviceIndex>  absentTtvxs;
};

#endif // TDCTTVXSMAPDIALOG_H
