#ifndef CONFIG_H
#define CONFIG_H
#include "mldiscover/DeviceIndex.h"
#include "DeviceSetup.h"
#include "mongo/StartupOptions.h"
#include "mongo/BaseConfig.h"
#include "base/RcRunId.h"

#include <QString>
#include <QMap>
#include <QMetaType>

class Config : public BaseConfig
{
public:
    Config(StartupOptions &startup_options);
    ~Config();
    bool read_config();
    bool write_config();
    void update_root();
    void debug_print();

    DeviceSetup &getConfig(const DeviceIndex &index);
    DeviceSetup &getCurrentConfig();
    bool isRun();
    bool has_enabled_device() const;
    DeviceIndex get_device_index_by_key(QString key);

public:
    RootConfig root;
    RootConfig default_root;
    QString program_type;
    QString program_version;
    QString program_index;
    QString configuration_name;
    RcRunId runId;
    bool run;

    bool debug_mode; // console argument
    bool mstreamShowTable;
    bool mstreamShowLog;
    bool global_mode;
    bool trace_device_info;
    bool show_power_current;
    QString configFileName;
    QString preset;
    bool allow_remote_control;
    int sort_column;
    bool sort_asc;
    bool show_cfg_widget;

    DeviceIndex curDev; // index for enabled selected device
    QMap<DeviceIndex, DeviceSetup> knownSetups;
    DeviceSetup default_setup; // allow to store last cfg even if knownSetups is empty
};

#endif // CONFIG_H


//    void loadSettings();
//    void saveSettings();
