#ifndef ORDERDIALOG_H
#define ORDERDIALOG_H

#include <QDialog>

#include "Config.h"
class QTableWidgetItem;
class DeviceDescription;
class QTableWidget;

namespace Ui {
class OrderDialog;
}

class OrderDialog : public QDialog
{
    Q_OBJECT

public:
    explicit OrderDialog(Config *config, QMap<DeviceIndex, DeviceDescription> knownDevDescr, QWidget *parent = nullptr);
    ~OrderDialog();
    static QList<QTableWidgetItem*> takeRow(QTableWidget *t, int row);
    static void setRow(QTableWidget *t, int row, const QList<QTableWidgetItem*>& rowItems);
    QMap<DeviceIndex, DeviceSetup> get_known_setups(){return config->knownSetups;}

private slots:
    void move_click();

private:
    DeviceIndex getIndexByRow(int row) const;
    void update_button_states();

    Ui::OrderDialog *ui;
    Config  *config;
    QMap<DeviceIndex, DeviceDescription> knownDevDescr;
};

#endif // ORDERDIALOG_H
