#ifndef DEVICECALIBRATION_H
#define DEVICECALIBRATION_H

#include <QMap>
#include <QMetaType>

class DeviceCalibration
{
public:
    DeviceCalibration() {
        nch = 16;
        clearBase();
    }

    void clearBase(){
        x1.clear();
        x4.clear();
        thrOffset.clear();
        for(int ch=0; ch<nch; ++ch) {
            x1[ch] = 0;
            x4[ch] = 0;
            thrOffset[ch] = 1920;
        }
    }

    QMap<int, double> x1; // ADC baseline for gain x1
    QMap<int, double> x4; // ADC baseline for gain x4
    QMap<int, int> thrOffset; // thrOffset // in dacValue 0-4095
    QMap<int, QVector<double> > inl;
    int nch;
};
Q_DECLARE_METATYPE(DeviceCalibration)

#endif // DEVICECALIBRATION_H
