#include "TqdcZmqPublisher.h"

#include "DeviceData.h"

TqdcZmqPublisher::TqdcZmqPublisher(QObject *parent)
    : ZmqPublisher(parent)
{}

void TqdcZmqPublisher::publish_event(const DeviceData &data)
{
    if(!socket) return;
    auto evIt = data.events.begin();
    while(evIt != data.events.end()) {
        const auto &event = *evIt;
        ++evIt;
        QString mess_str = QString("TQDC %1 Ev_%2")
                .arg(data.index.getSerial(), 8, 16, QChar('0'))
                .arg(event.evNum);
        mess_str += QString("; time:%1.%2 flags:%3")
                .arg(event.taiSec).arg(event.taiNSec).arg(event.taiFlags);

        auto adcChIt = event.adcEvents.begin();
        while (adcChIt != event.adcEvents.end()) {
            const auto &adcChEvents = adcChIt->second;
            auto adcChEvIt = adcChEvents.begin();
            while (adcChEvIt != adcChEvents.end()) {
                mess_str += QString("; ch:%1 t:%2")
                        .arg(adcChEvIt->ch).arg(adcChEvIt->adcTs);
                auto wfIt = adcChEvIt->wf.begin();
                while(wfIt != adcChEvIt->wf.end()) {
                    mess_str += QString(" %1").arg(*wfIt, 0, 'f', 0);
                    ++wfIt;
                }

                ++adcChEvIt;
            }

            ++adcChIt;
        }

        auto tqdcChIt = event.tqdcEvents.begin();
        while (tqdcChIt != event.tqdcEvents.end()) {
            mess_str += QString("; ch:%1").arg(tqdcChIt->first);
            const auto &tqdcChEvents = tqdcChIt->second;
            auto tqdcChEvIt = tqdcChEvents.begin();
            while (tqdcChEvIt != tqdcChEvents.end()) {
                if(tqdcChEvIt->leadingTime)
                    mess_str += QString(" l:%1").arg(tqdcChEvIt->leadingTime);
                if(tqdcChEvIt->trailingTime)
                    mess_str += QString(" t:%1").arg(tqdcChEvIt->trailingTime);
                ++tqdcChEvIt;
            }

            ++tqdcChIt;
        }

        publish(mess_str);
//        qInfo() << mess_str;
    }
}
