#ifndef DEVICEGLOB_H
#define DEVICEGLOB_H

#include <QElapsedTimer>
#include <QObject>
#include <QThread>
#include <QProcess>

#include "mldiscover/DeviceIndex.h"
#include "TtvxsStatus.h"

class QThread;
class QProcess;
class TtvxsDevice;

class DeviceGlob : public QObject
{
    Q_OBJECT
public:
    DeviceGlob(QObject *parent = nullptr);
    DeviceGlob(DeviceIndex i, QObject *parent = nullptr);
    ~DeviceGlob();
    void disconnectFromDev(QElapsedTimer *t=nullptr);
    void startThread();
    void connectToDev(DeviceIndex i);

signals:
    void deleteHardware(DeviceIndex) const;

public:
    DeviceIndex index;
    TtvxsDevice * dev;
    QThread devThread;
    QProcess * mstreamProc;
    TtvxsStatus lastDevStatus;
};

#endif // DEVICEGLOB_H
