#include "StatPreset.h"

const QString StatPreset::DEFAULT_ITEM_NAME = "stat_preset";

StatPreset StatPresetFabric::getPreset(int type)
{
    StatPreset sp;
    sp.type = static_cast<StatPreset::STAT_TYPE>(type);
    switch (type) {
    case StatPreset::STAT_DEBUG:
    {
        sp.label = "debug";
//        sp.regs << 0x0226;
        return sp;
    }
    case StatPreset::STAT_Test:
    {
        sp.label = "test";
        sp.regs.clear();
//        sp.regs << 0x0227;
        return sp;
    }
    case StatPreset::STAT_DEFAULT:
    default :
        return StatPreset();
    }
}

QList<StatPreset> StatPresetFabric::getAllPresets()
{
    QList<StatPreset> all_presets;
    for(int i=0; i<StatPreset::STAT_PRESET_CNT; ++i)
        all_presets << getPreset(i);
    return all_presets;
}

bool StatPreset::root_to_variables(RootConfig root)
{
    label = root.get_data<QString>("label", label);
    if(!label.isEmpty()) {
        for(auto p : StatPresetFabric::getAllPresets()){
            if(p.label == label){
                *this = p;
                return true;
            }
        }
    }
    *this = StatPreset();
    return true;
}

RootConfig StatPreset::variables_to_root() const
{
    RootConfig root_to_return(DEFAULT_ITEM_NAME);
    root_to_return.set_data("label", label);
    RootConfig root_regs;
    for(int i=0; i<regs.size(); ++i) {
        root_regs.set_data(QString("%1").arg(i, 2, 10, QChar('0')),
                           regs[i]);
    }
    root_regs.item_name= "regs";
    root_to_return.append_child(root_regs);
    return  root_to_return;
}
