#ifndef STATPRESET_H
#define STATPRESET_H

#include <QList>
#include <QString>
#include <QVector>

#include <mongo/RootConfig.h>

struct StatPreset {
     const static QString DEFAULT_ITEM_NAME;

    enum STAT_TYPE {STAT_DEFAULT,
                    STAT_DEBUG,
                    STAT_Test,
                    STAT_PRESET_CNT};
    StatPreset() {
        type = STAT_DEFAULT;
        label = "default";
        regs    << 0x004B
                << 0x004C
                << 0X004D

                << 0x4001
                << 0x4002
                << 0x4003
                << 0x4004
                << 0x4005
                << 0x4006
                << 0x4007
                << 0x4008
                << 0x4009
                << 0x400A
                << 0x400B
                << 0x400C;
    }
    bool root_to_variables(RootConfig root);
    RootConfig variables_to_root() const;

    STAT_TYPE type;
    QString label;
    QVector<quint16> regs;
};

class StatPresetFabric {
public:
    static StatPreset getPreset(int type);
    static QList<StatPreset> getAllPresets();
};

#endif // STATPRESET_H
