#ifndef TTVXSAUXCOUNTERS_H
#define TTVXSAUXCOUNTERS_H

#include <QString>
#include <QVector>

class TtvxsAuxCounters
{
public:
    TtvxsAuxCounters();
    TtvxsAuxCounters& operator=(const TtvxsAuxCounters & ) = default;

    const static int CNT_NUM = 28;

    static QString getAuxDescr(int i);

    QString getUpTime() const;
    quint64 getUpTimeSec() const;
    QString getTtlCnt() const;
    QString getTtlRate(const TtvxsAuxCounters &reper) const;
    QString getSfpCnt() const;
    QString getSfpRate(const TtvxsAuxCounters &reper) const;
    QString getBusyTime(int ch) const;
    double getBusyTimeUs(int ch) const;
    QString getResultingBusyTime() const;
    double getResultingBusyTimeUs() const;
    QString getRunTime() const;
    quint64 getRunTimeSec() const;
    QString getTtlRunCnt() const;
    QString getSfpRunCnt() const;
    QString getTrigRunCandCnt() const;
    QString getTrigRunAcceptCnt() const;
    QString getRunTrigRate(const TtvxsAuxCounters &reper) const;
    QVector<quint64> data;
};



#endif // TTVXSAUXCOUNTERS_H
