#ifndef TTVXSDEVICE_H
#define TTVXSDEVICE_H

#include <QObject>
#include <QMetaType>

#include "TtvxsConfig.h"
#include "TtvxsStatus.h"

#include "mregdev/qtmregdevice.h"
#include "mldiscover/DeviceIndex.h"

class RcRunId;

namespace mlink {
class RegOpVector;
}

class TtvxsDevice : public QtMregDevice
{
    Q_OBJECT
public:
    explicit TtvxsDevice(DeviceIndex devIndex, QObject *parent=nullptr);

signals:
    void statusUpdated(const TtvxsStatus &status);
    void trigEvNumResponse(int check_index, quint64 evNum);
    void devEvNumResponse(int check_index, quint64 devSerial, quint64 evNum);

public slots:
    void writeSetup();
    void setSetup(const TtvxsConfig &cfg);
    void evNumReset(DeviceIndex index=DeviceIndex());
    void onTempChanged(double temp);
    void onRestartAll(const RcRunId &runId);
    void softClear(DeviceIndex i);
    void clearStat(DeviceIndex i);
    void evNumRequest(int check_index, bool top_level);
    void sendResetTimestamp(DeviceIndex i=DeviceIndex());

protected slots:
    virtual void statusPoll();
    virtual void on_deviceConnected();
    virtual void on_deviceDisconnected();

private:
    mlink::RegOpVector writeStatCfg(const TtvxsConfig &cfg);

    TtvxsConfig configCashe;
    TtvxsStatus status;
    bool configValid;
};

#endif // TTVXSDEVICE_H
