/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef BASEMAINWINDOW_H
#define BASEMAINWINDOW_H

#include <QMainWindow>

class BaseMainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit BaseMainWindow(QWidget *parent = nullptr);
    virtual ~BaseMainWindow();

protected slots:
    void actionQuit();
    void actionAbout();

protected:
    virtual void closeEvent(QCloseEvent *event);
    virtual void setupMenu();
};

#endif // BASEMAINWINDOW_H
