/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef CONFIGSELECTOR_H
#define CONFIGSELECTOR_H

#include <QString>

class ConfigSelector {
public:
    ConfigSelector(const QString &_type = "",
                   const QString &_index = "",
                   const QString _name = "default")
        :
        program_type(_type),
        program_index(_index),
        configuration_name(_name)
    { }

    QString getIndex() const { return program_index; }
    QString getTypeName() const { return program_type; }
    QString toString() const {
        return  QString("%1  |  Program index: %2  |  Configuration name: %3")
                           .arg(program_type)
                           .arg(program_index)
                           .arg(configuration_name);

    }

    QString program_type;
    QString program_index;
    QString configuration_name;
};

#endif // CONFIGSELECTOR_H
