/*
**    Copyright 2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "util.h"

#include <algorithm>

#include <QObject>
#include <QString>
#include <QStringList>

QString qObjectAncestryStr(const QObject *obj)
{
    QStringList sl;
    for (const QObject *p = obj; p; p = p->parent()) {
        const QString &classStr = p->metaObject()->className();
        const QString &objStr = p->objectName();
        QString s = classStr;
        if (! objStr.isEmpty() && (objStr != classStr))
            s += QString("[%2]").arg(objStr);
        sl += s;
    }
    std::reverse(std::begin(sl), std::end(sl));
    return sl.join(".");
}
