#ifndef FLASHDEVTYPES_H
#define FLASHDEVTYPES_H

#include <stdint.h>

const uint32_t REG_CMD = 0x5;
const uint32_t REG_READBACK = 0x6;
const uint32_t REG32_DATA_ADDR = 0x8;
const uint32_t REG_STAT_1 = 0xA;
const uint32_t REG_STAT_2 = 0xB;
const uint32_t REG_FLASH_ADDR = 0xfe;
const uint32_t REG_DATA = 0x80;

const int CMD_WRITE = 0x02;
const int CMD_READ = 0x03;
const int CMD_SE = 0xd8; // Sector erase
const int CMD_BE = 0xc7; // Bulk erase
const int CMD_WRITE_EN = 0x06;
const int CMD_WRVECR = 0x61;
const int CMD_RDSR = 0x05;
const int CMD_RDID = 0x9f; // JEDEC ID
const int JEDEC_ID_OK = 0x20;

const int SECTOR_ERASE_TIMEOUT = 1300;
const int BULK_ERASE_TIMEOUT = 200000;
const int WRITE_TIMEOUT_MS = 100;
const int READ_TIMEOUT_MS = 100;

const int SECTOR_SIZE = 0x10000; // 64 kByte

const int DEV_FULL_MEM = 0x1000000; // 16MB
const uint32_t MAX_BLOCK_SIZE = 256; // bytes

#endif // FLASHDEVTYPES_H
