#ifndef CONFIG_H
#define CONFIG_H

#include "mongo/BaseConfig.h"

class GeneratorConfig : BaseConfig
{
public:
    GeneratorConfig(QString program_type,
                    QString program_index,
                    QString configuration_name,
                    bool run
                    );
    ~GeneratorConfig();
    bool read_config();
    bool write_config();
    void update_root();
    void debug_print();

    RootConfig root;
    RootConfig default_root;
    QString program_type;
    QString program_index;
    QString configuration_name;
    int run_number;
    QString run_index;

    bool run;
    int spill_count;
    int spill_size;
    int interspill_size;
    int spill_events;
    int event_length;
};

#endif // CONFIG_H
