/*
**    Copyright 2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef RCCLIENTDATA_H
#define RCCLIENTDATA_H

#include "ClientConfig.h"
#include "RunStates.h"

#include <QString>
#include <QUuid>

struct StatusBackup {
    QString prevStatus;
    quint32 spillNum;
    bool isActive(quint32 curSpillNum) const {
        return spillNum == curSpillNum || spillNum+1 == curSpillNum;
    }
};

class Client;

struct ClientInfo {
    int getId() const { return cfg.id; }
    ClientConfig cfg;
    Client *client    = nullptr;
    RUN_STATES state  = RS_INIT;
    bool ready4Run    = false;
    bool backPressure = false;
    QUuid prog_uuid;
};

class RcClientData
{
public:
    RcClientData();
};

#endif // RCCLIENTDATA_H
