//
//    Copyright 2016 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef STATSACCUMULATOR_H
#define STATSACCUMULATOR_H

#include <QVector>

class StatsAccumulator
{
public:
    StatsAccumulator(int size) : initSize(size), pos(0), nent(0), v(initSize) {}
    int size() const;
    void add(double value);
    double mean() const;
    double stdev() const;
    void clear();
private:
    int initSize;
    int pos;
    int nent;
    QVector<double> v;
};


#endif // STATSACCUMULATOR_H
