#ifndef PacketReceiver_H
#define PacketReceiver_H

#include <QObject>
#include "LinkStats.h"

class QByteArray;
namespace mlink {
class MlinkDeviceInterfaceBase;
}
class PacketReceiver: public QObject
{
    Q_OBJECT

public:
    explicit PacketReceiver(QObject *parent = nullptr);
    void reset();
    size_t handle_rx_pkt(mlink::MlinkDeviceInterfaceBase *pexml);
    void printLinkStats() const;

Q_SIGNALS:
    void bytesRead(const QByteArray &data);

protected:
    unsigned short save_frame_seq_110 = 0;
    LinkStats linkStats;
private:
    QByteArray rxDataBuf;
};

#endif /* PacketReceiver_H */
