/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "device_id.h"

const char *getDeviceTypeName(int deviceId)
{
    switch (deviceId) {
    case DEVICE_ID_8CADC: return "8CADC";
    case DEVICE_ID_ADC8E: return "ADC8E";
    case DEVICE_ID_ADC8BEDRS: return "ADC8BEDRS";
    case DEVICE_ID_ADC16LTCM: return "ADC16LTCM";
        //    case DEVICE_ID_ADC16LTCS: return "ADC16LTCS";
    case DEVICE_ID_ADC32P: return "ADC32P";
    case DEVICE_ID_ADC64: return "ADC64";
    case DEVICE_ID_ADC64S2: return "ADC64S2";
    case DEVICE_ID_ADC64WR: return "ADC64WR";
    case DEVICE_ID_ADC64VE: return "ADC64VE";
    case DEVICE_ID_ADC64VE_XGE: return "ADC64VE-XGE";
    case DEVICE_ID_ADC64ECAL: return "ADC64ECAL";
    case DEVICE_ID_ADCM16: return "ADCM16";
    case DEVICE_ID_ADCM163: return "ADCM163";
    case DEVICE_ID_ADCM164: return "ADCM164";
    case DEVICE_ID_BPM4100: return "BPM4100";
    case DEVICE_ID_BRIC: return "BRIC";
    case DEVICE_ID_CTF6: return "CTF6";
    case DEVICE_ID_CRU16WR: return "CRU16WR";
    case DEVICE_ID_EVADC: return "EVADC";
    case DEVICE_ID_FVME: return "FVME";
    case DEVICE_ID_HRB128E: return "HRB128E";
    case DEVICE_ID_HRB6ASD: return "HRB6ASD";
    case DEVICE_ID_MSC8E: return "MSC8E";
    case DEVICE_ID_MSC16VE_E: return "MSC16VE_E";
    case DEVICE_ID_MSC16VE_TM: return "MSC16VE_TM";
    case DEVICE_ID_NUCLORF: return "NUCLORF";
    case DEVICE_ID_TEST: return "TEST";
    case DEVICE_ID_TTVXS: return "TTVXS";
    case DEVICE_ID_TDC64VHLE: return "TDC64VHLE";
    case DEVICE_ID_TDC72VXS: return "TDC72VXS";
    case DEVICE_ID_TQDC16VS_DIG: return "TQDC16VS_DIG";
    case DEVICE_ID_TQDC16VS_E: return "TQDC16VS_E";
    case DEVICE_ID_TTB9V: return "TTB9V";
    case DEVICE_ID_U40VE: return "U40VE";
    case DEVICE_ID_U40VE_8SPI: return "U40VE-8SPI";
    case DEVICE_ID_U40VE_IDEAS: return "U40VE-IDEAS";
    case DEVICE_ID_U40VE_RC: return "U40VE-RC";
    case DEVICE_ID_U40VE_SI: return "U40VE-SI";
    case DEVICE_ID_UT24VE: return "UT24VE";
    case DEVICE_ID_VME_TRIG: return "TRIG";
    case DEVICE_ID_VMM128RO: return "VMM128RO";

    case DEVICE_ID_UNKNOWN: return "Unknown";
    case DEVICE_ID_AnyDevice: return "AnyDevice";
    }
    return "Unknown";
}
