/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DEVICE_ID_H
#define DEVICE_ID_H

typedef enum {
    DEVICE_ID_UNKNOWN       = 0,
    DEVICE_ID_VME_TRIG      = 0x0A, //  0x0A00,
    DEVICE_ID_TEST          = 0x55, // 0x5500,
    DEVICE_ID_TQDC16VS_DIG  = 0x89, // 0x8900
    DEVICE_ID_8CADC         = 0xB3, // 0xB300,
    DEVICE_ID_ADCM16        = 0xB4, // 0xB400,
    DEVICE_ID_ADC16LTCM     = 0xB5, // 0xB500,
    //        DEVICE_ID_ADC16LTCS     = 0xB5, // 0xB501,
    DEVICE_ID_ADCM163       = 0xB6, // 0xB600,
    DEVICE_ID_BPM4100       = 0xB7, // 0xB700,
    DEVICE_ID_ADC8E         = 0xB8, // 0xB800,
    DEVICE_ID_EVADC         = 0xB9, // 0xB900,
    DEVICE_ID_ADC64         = 0xBA, // 0xBA00,
    DEVICE_ID_NUCLORF       = 0xBB, // 0xBB00,
    DEVICE_ID_BRIC          = 0xBC, // 0xBC00,
    DEVICE_ID_MSC8E         = 0xBD, // 0xBD00,
    DEVICE_ID_ADCM164       = 0xBE, // 0xBE00,
    DEVICE_ID_ADC8BEDRS     = 0xBF, // 0xBF00,
    DEVICE_ID_HRB128E       = 0xC1, // 0xC100,
    DEVICE_ID_HRB6ASD       = 0xC2, // 0xC200,
    DEVICE_ID_ADC32P        = 0xC3, // 0xC300,
    DEVICE_ID_TTB9V         = 0xC4, // 0xC400,
    DEVICE_ID_ADC64S2       = 0xC5, // 0xC500,
    DEVICE_ID_U40VE         = 0xC6, // 0xC600,
    DEVICE_ID_CTF6          = 0xC8, // 0xC800,
    DEVICE_ID_UT24VE        = 0xC9, // 0xC900,
    DEVICE_ID_ADC64WR       = 0xCA, // 0xCA00,
    DEVICE_ID_U40VE_8SPI    = 0xCB, // 0xCB00,
    DEVICE_ID_U40VE_RC      = 0xCC, // 0xCC00,
    DEVICE_ID_U40VE_IDEAS   = 0xCD, // 0xCD00,
    DEVICE_ID_U40VE_SI      = 0xCE, // 0xCE00,
    DEVICE_ID_TTVXS         = 0xCF, // 0xCF00,
    DEVICE_ID_TDC72VXS      = 0xD0, // 0xD000,
    DEVICE_ID_FVME          = 0xD1, // 0xD100,
    DEVICE_ID_TDC64VHLE     = 0xD3, // 0xD300,
    DEVICE_ID_ADC64VE       = 0xD4, // 0xD400,
    DEVICE_ID_TQDC16VS_E    = 0xD6, // 0x8900,
    DEVICE_ID_VMM128RO      = 0xDB, // 0xDB00,
    DEVICE_ID_MSC16VE_TM    = 0xDC, // 0xD800,
    DEVICE_ID_MSC16VE_E     = 0xD8, // 0xD800,
    DEVICE_ID_ADC64VE_XGE   = 0xD9, // 0xD900,
    DEVICE_ID_ADC64ECAL     = 0xDE, // 0xDE00,
    DEVICE_ID_CRU16WR       = 0xE0, // 0xE000,
    DEVICE_ID_AnyDevice     = 0xFF //  0xFFFF
} DeviceId;

const char *getDeviceTypeName(int deviceId);

#endif // DEVICE_ID_H
