#ifndef CMSUBDIALOG_H
#define CMSUBDIALOG_H

#include "mongo/BaseConfig.h"
#include "mongo/RootConfig.h"
#include "CMTypes.h"

#include <QDialog>
#include <QMap>
#include <QStringList>

namespace Ui {
class CMSubDialog;
}

class CMSubDialog : public QDialog
{
    Q_OBJECT
public:
    explicit CMSubDialog(CMDialogType type,
                         RootConfig root,
                         QString program_type,
                         QString program_index,
                         QString configuration_name,
                         QWidget *parent = nullptr);
    ~CMSubDialog();

signals:
    void switch_to(QString program_index, QString configuration_name);

private slots:
    void on_line_edit_program_index_textEdited(const QString &arg1);
    void on_line_edit_config_name_textChanged(const QString &arg1);
    void on_button_box_ok_cansel_accepted();
    void on_push_button_and_open_clicked();

private:
    void check_input_validity();
    QString typeStr() const;

    Ui::CMSubDialog *ui;
    CMDialogType type;
    RootConfig root_config;
    QString program_type;
    QString program_index;
    QString configuration_name;

    QMap<QString, QStringList> config_map;
    QString program_index_entered;
    QString configuration_name_entered;
    BaseConfig base_config;

};

#endif // CMSUBDIALOG_H
