#ifndef DAQCONFIG_H
#define DAQCONFIG_H

#include <QObject>
#include <QString>
#include <QSettings>

enum DaqConfigTypes { DaqConfigAdc64,
                      DaqConfigAdc64System,
                      DaqConfigEventBuilder,
                      DaqConfigGenerator,
                      DaqConfigScheduler,
                      DaqConfigHrbAnalyzer,
                      DaqConfigHrbSystem,
                      DaqConfigMStream,
                      DaqConfigRunControl,
                      DaqConfigTdcControl,
                      DaqConfigTdcViewer,
                      DaqConfigTQDC,
                      DaqConfigIdeas,
                      DaqConfigVmeDaq,
                      DaqConfigLand,
                      DaqConfigTtvxs
                    };
Q_DECLARE_METATYPE(DaqConfigTypes)

class DaqConfig
{
public:
    DaqConfig(DaqConfigTypes, QString i=QString());
    QString getIndex() const { return index; }
    void setIndex(QString i);
    QString getTypeName() const;
    static QString getTypeName(DaqConfigTypes t);
    QSettings &getSettings() { return index.isEmpty() ? localSet : globalSet; }
    void eraseSettings();
    static QStringList get_all_types();

private:
    QSettings globalSet;
    QSettings localSet;
    QString index;
    DaqConfigTypes type;
};

#endif // DAQCONFIG_H
