#ifndef DATABASE_ENGINE_H
#define DATABASE_ENGINE_H

#include <QObject>
#include <QDateTime>
#include <QSqlDatabase>

enum {
    DB_STATUS_OK = 0,
    DB_STATUS_ERROR = 1,
};

class DaqDataBase : public QObject
{
    Q_OBJECT

public:
    explicit DaqDataBase(QObject *parent = nullptr);
    QSqlDatabase getConnection();
    bool getDataBaseStatus();
    QSqlError getLastDbError();
    QString toString();

signals:
    void setStatus(const QString& status, const int& level);

protected:
    QVector<int> selectQuery(QSqlDatabase &db, QString table, QMap<QString, QVariant> vals) const;
    bool insertQuery(QSqlDatabase &db, QString table, QMap<QString, QVariant> vals, int *id=nullptr) const;

private:
    QString getPreferedSection() const;
    QString selectedConnection;
};

#endif // DATABASE_ENGINE_H
