#ifndef BASECONFIG_H
#define BASECONFIG_H

#include <QObject>
#include <QString>
#include <QObject>
#include <QDateTime>
#include <QTime>

#include "RootConfig.h"
#include "LocalDB.h"
#include "MongoConsts.h"

#ifdef MONGO_DRIVERS
#include "MongoDB.h"
#endif

class BaseConfig
{
public:
    BaseConfig();
    void init(QString program_type);
    RootConfig read_config(QString program_type,
                           QString program_index = PROGRAM_INDEX_DEFAULT,
                           QString config_name = PROGRAM_CONFIG_DEFAULT);
    bool write_config(RootConfig root);
    bool write_history_config(RootConfig root);
    int check_run_number(QString program_type, QString run_index, int run_number);
    bool write_device_config(RootConfig root);
    QMap<QString, QStringList> get_config_map(QString program_type);
    QDateTime get_date_of_modification(QString program_type,
                                       QString program_index,
                                       QString config_name = PROGRAM_CONFIG_DEFAULT);
    bool delete_config(QString program_type,
                       QString program_index=PROGRAM_INDEX_DEFAULT,
                       QString config_name = PROGRAM_CONFIG_DEFAULT);
    bool transform_to_phantom(RootConfig root_config);
    #ifdef MONGO_DRIVERS
        MongoDB mongo_db;
        bool synchronization(QString program_type);
    #endif
        LocalDB local_db;
     void root_debug_print(RootConfig root);
     void init_tests();
     bool mongo_alive;
private:
    //---debug modules

    bool type_cast_warning;
};

#endif // BASECONFIG_H

//QSharedPointer<QSettings> settings_saved;
//QSharedPointer<QSettings> settings_history;
