#ifndef LOCALDB_H
#define LOCALDB_H

#include <QSettings>

#include "RootConfig.h"
#include "MongoConsts.h"

class LocalDB
{
public:
    LocalDB();
    virtual ~LocalDB();
    void init(QString program_type);
    void sync();
    bool local_db_chekup();
    RootConfig read_config(QString program_type,
                           QString program_index = PROGRAM_INDEX_DEFAULT,
                           QString config_name = PROGRAM_CONFIG_DEFAULT);
    bool write_config(RootConfig root, bool doSync=true);
    bool write_history_config(RootConfig root);
    int check_run_number(QString program_type, QString run_index, int run_number);
    bool write_device_config(RootConfig root);
    QMap<QString, QStringList> get_config_map(QString program_type);
    QMap<QString, QMap<QString, RootConfig>> get_rootconfig_map(QString program_type);
    QDateTime get_date_of_modification(QString program_type,
                                       QString program_index = PROGRAM_INDEX_DEFAULT,
                                       QString config_name = PROGRAM_CONFIG_DEFAULT);
    bool delete_config(QString program_type,
                       QString program_index=PROGRAM_INDEX_DEFAULT,
                       QString config_name = PROGRAM_CONFIG_DEFAULT);

    void root_to_local(RootConfig root, QSettings  * settings);
    RootConfig local_to_root(QSettings *settings);

    void rename_date_of_creation();

private:
    void remove_brocken_docs_from_local(QSettings *s);
    void split_saved_by_indexes(QString prog_type);
    void tree_traversing(QSettings * settings, RootConfig root);
    RootConfig settings_traversing(QSettings * settings);
    void update_settings_saved(QString type, QString index);

    QSettings *settings_saved;
    QString cur_prog_type;
    QString cur_prog_index;
    QSettings *settings_history;
};

#endif // LOCALDB_H

//--- garbage ---

