//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef WAVEFORMMODEL_H
#define WAVEFORMMODEL_H

#include <qxw/qxw_global.h>
#include <qxw/WaveformData.h>

class QXW_EXPORT WaveformModel {
public:
    //  void simulate();
    void resize(unsigned int n) {wd.resize(n);}
    WaveformData get(int channel) const {return wd[channel];}
    WaveformDataAll get() const {return wd;}
    void set(const WaveformDataAll&w) {wd = w;}
    int size() const {return wd.size();} // number of waveforms

protected:
    WaveformDataAll wd;
};

#endif // WAVEFORMMODEL_H
