#ifndef RUNCONTROLCOMMANDS_H
#define RUNCONTROLCOMMANDS_H

#include <QString>

const QString RC_CMD_DESCR = "description"; // sort description like "event-builder"
const QString RC_CMD_START = "start";
const QString RC_CMD_CONFIG = "config";
const QString RC_CMD_STOP = "stop";
const QString RC_CMD_ERROR = "error"; // error  <runIndex> <runNumber> <errString>
const QString RC_CMD_WARN = "warn"; // warn  <runIndex> <runNumber> <warnString>
const QString RC_CMD_BACK_PRESSURE = "backPressure"; // backPressure <runIndex> <runNumber> [0|1]
const QString RC_CMD_VME_FLAG = "vmeFlag"; // vmeFlag [0|1]
const QString RC_CMD_STATE = "state"; // deprecated
const QString RC_CMD_STATUS = "status";
const QString RC_CMD_EV_NUM_CHECK = "EvNumCheck"; // EvNumCheck <checkIndex>
                                                  // success EvNumCheck <EvNum1> ... <EvNumN>
const QString RC_CMD_READY4RUN = "ready4run"; // ready4run [0|1]
const QString RC_CMD_SUCCESS_PREFIX = "success";
const QString RC_CMD_FAILED_PREFIX = "failed";
const QString RC_CMD_END = "\r\n";

const QString RC_STATE_STOPPED = "stopped";
const QString RC_STATE_STARTED = "started";
const QString RC_STATE_STOPING = "stopping";
const QString RC_STATE_STARTING = "starting";
const QString RC_STATE_ERROR = "error";

const quint32 RC_MSG_CONFIG_OLD = 453;
const quint32 RC_MSG_CMD_OLD = 897;
const quint32 RC_MSG_CONFIG = 0xAE2E6D00;
const quint32 RC_MSG_CMD = 0xAE2E6D01;
/*
 *  RC                  Client
 *                  <-  description <PROGRAMM_DESCRIPTION_STR> \r\n
 *                  <-  state <PROGRAMM_STATE_STR> \r\n
 *  start Glob 25 \r\n   ->
 *                  <-  success start Glob 25 \r\n
 *                  <-  success start Glob 25 \r\n
 *                  <-  status <PROGRAMM_STATUS_STR> \r\n
 *                      ...
 *                  <-  status <PROGRAMM_STATUS_STR> \r\n
 *  stop Glob 25\r\n       ->
 *                  <-  success stop Glob 25 \r\n
 *  EvNumCheck <checkIndex> \r\n       ->
 *                  <-  success EvNumCheck <checkIndex> <EvNum1> <EvNum2> ... <EvNumN> \r\n
*/

#endif // RUNCONTROLCOMMANDS_H
