#ifndef ZMQDIALOG_H
#define ZMQDIALOG_H

#include <QDialog>

#include "ZmqTypes.h"

namespace Ui {
class ZmqDialog;
}

class ZmqDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ZmqDialog(QWidget *parent = nullptr);
    ~ZmqDialog();
    void setConfig(const ZmqConfig &config);

signals:
    void zmq_cfg_change(const ZmqConfig &cfg) const;

private slots:
    void on_checkBoxEnable_toggled(bool en);
    void on_checkBoxTest_toggled(bool en);
    void on_spinBox_valueChanged(int p);
    void on_checkBoxPrint_toggled(bool print);

public slots:
    void statusUpdated(const ZmqStatus &s);

private:
    Ui::ZmqDialog *ui;
    ZmqConfig cfg;
    bool block_change_signal=false;
};

#endif // ZMQDIALOG_H
