#include "ZmqTypes.h"

#include <QSettings>

#include "mongo/RootConfig.h"

void ZmqConfig::loadSettings(QSettings &settings)
{
    settings.beginGroup("ZMQ");
    enabled = settings.value("zmq_en").toBool();
    port = settings.value("zmq_port").toInt();
    test_mode = settings.value("zmq_test").toBool();
    print_messages = settings.value("zmq_print").toBool();
    settings.endGroup();
}

void ZmqConfig::saveSettings(QSettings &settings) const
{
    settings.beginGroup("ZMQ");
    settings.setValue("zmq_en", enabled);
    settings.setValue("zmq_port", port);
    settings.setValue("zmq_test", test_mode);
    settings.setValue("zmq_print", print_messages);
    settings.endGroup();
}

void ZmqConfig::root_to_variables(RootConfig root)
{
    enabled   = root.get_data<bool>("enabled", enabled);
    port      = root.get_data<int> ("port", port);
    test_mode = root.get_data<bool>("test_mode", test_mode);
    print_messages = root.get_data<bool>("print_messages", print_messages);
}

RootConfig ZmqConfig::variables_to_root()
{
    RootConfig root_to_return("ZMQ");

    root_to_return.set_data("enabled", enabled);
    root_to_return.set_data("port", port);
    root_to_return.set_data("test_mode", test_mode);
    root_to_return.set_data("print_messages", print_messages);

    return root_to_return;
}
